// ButtonSprite.h

typedef struct ButtonSpriteRec ButtonSpriteRec;
typedef ButtonSpriteRec *ButtonSpritePtr, **ButtonSpriteHndl;

enum ButtonStatesEnum
{
	kButtonUp=0,
	kButtonMouseOver,
	kButtonMouseDown,
	kButtonDisabled,
	kMaxNumberOfButtonStates
};

enum ButtonKeyStatesEnum
{
	kMenuKeyInitPressed=1,
	kMenuKeyFlash
};

enum CursorState
{
	kCursorUp=0,			//Mouse button is up
	kCursorDown,			//Mouse button is held down
	kCursorInitDown,		//Mouse button is clicked
	kControlBeingDragged	//Mouse is dragging a control
};

extern Boolean				gButtonsAreActive;			// [DB]


typedef SW_FUNC void (*ButtonProcPtr)(ButtonSpritePtr srcButtonP, int ButtonStateChanged);

typedef SW_FUNC void (*SetButtonCursorProcPtr)(int CursorIsInAButton);

struct ButtonSpriteRec
{
	SpriteRec				SWSpriteData;
							
	//Menu Data
	short					TrackingMouseXInit, TrackingMouseYInit, TrackingMouseX, TrackingMouseY,
							TrackingMouse, IsButtonEnabled, MenuKeyPressed, ControlsFlashTime,
							LastButtonState;
	ButtonProcPtr			DrawButtonUp, DrawButtonMouseOver, DrawButtonDown, DrawButtonDisabled;
	MoveProcPtr				ButtonAction;
};

void SWGInitButtonSpriteWorld(SetButtonCursorProcPtr SetButtonCursorProc);
void SWGUpdateButtonData(void);
void SWGSetUpButtonCallbacks(ButtonSpritePtr srcButtonP, ButtonProcPtr DrawButtonUp,
							ButtonProcPtr DrawButtonMouseOver, ButtonProcPtr DrawButtonDown, 
							ButtonProcPtr DrawButtonDisabled, MoveProcPtr ButtonAction);
void SWGEnableButton(ButtonSpritePtr ButtonSprite, int IsButtonEnabled);
SW_FUNC void ButtonMoveProc(SpritePtr srcSpriteP);

// end
